<?php namespace Hugh\MultiCurl;

use Hugh\Curl\Builder as CurlBuilder;

class Builder {
    private $mCurl = null;
    private $curls = [];

    public function __construct() {
        $this->mCurl = curl_multi_init();
    }
    public function add(CurlBuilder $curl) {
        curl_multi_add_handle($this->mCurl, $curl);
        $this->curls[] = $curl;
    }
    public function go() {
        do {
            $status = curl_multi_exec($this->mCurl, $active);
            if ($active) {
                curl_multi_select($this->mCurl);
            }
        } while ($active && $status == CURLM_OK);
        curl_multi_close($this->mCurl);
        $result = [];
        foreach ($this->curls as $curl) {
            $result[] = curl_multi_getcontent($curl);
        }
        return $result;
    }

}
